from django import forms
from django.utils.translation import gettext_lazy as _


class AddStockForm(forms.Form):
    part_number = forms.CharField(label=_("Component"))
    properties = forms.JSONField(initial={}, label=_("Properties"), required=False)
    quantity = forms.IntegerField(min_value=1, label=_("Quantity"))
    original_quantity = forms.IntegerField(min_value=1, label=_("Original quantity"))
    total_value = forms.DecimalField(
        min_value=0, max_digits=8, decimal_places=2, label=_("Total value")
    )
    location = forms.CharField(label=_("Location"), widget=forms.Textarea)
    owner = forms.CharField(label=_("Owner"))


AddStockFormSet = forms.formset_factory(AddStockForm, extra=0)
