# Generated by Django 5.1.1 on 2024-09-16 22:00

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("lelcsc_core", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="Component",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("part_number", models.CharField(max_length=30)),
            ],
        ),
        migrations.CreateModel(
            name="Property",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=50)),
                (
                    "filterable",
                    models.BooleanField(
                        help_text="Whether this property can be used to filter components"
                    ),
                ),
                (
                    "type",
                    models.CharField(
                        choices=[("quantity", "Quantity"), ("text", "Text")],
                        max_length=8,
                    ),
                ),
                (
                    "searchable",
                    models.BooleanField(
                        help_text="Whether this property should be used in search"
                    ),
                ),
                (
                    "unit",
                    models.CharField(
                        help_text="Symbol of this quantity's unit of measurement",
                        max_length=3,
                    ),
                ),
                (
                    "scale",
                    models.SmallIntegerField(
                        help_text="Exponent of the smallest possible value"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Stock",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("quantity", models.PositiveIntegerField()),
                ("original_quantity", models.PositiveIntegerField()),
                ("total_value", models.DecimalField(decimal_places=2, max_digits=8)),
                ("location", models.TextField()),
                ("owner_name", models.CharField(max_length=150)),
                (
                    "component",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        to="lelcsc_core.component",
                    ),
                ),
                (
                    "owner",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Value",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("text", models.TextField()),
                ("integer", models.BigIntegerField()),
                (
                    "component",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="lelcsc_core.component",
                    ),
                ),
                (
                    "property",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="lelcsc_core.property",
                    ),
                ),
            ],
            options={
                "unique_together": {("component", "property")},
            },
        ),
        migrations.AddField(
            model_name="component",
            name="properties",
            field=models.ManyToManyField(
                through="lelcsc_core.Value", to="lelcsc_core.property"
            ),
        ),
    ]
