from django.db import models

from .auth import User
from .component import Component
from .mixins import HasTimestamps


class Stock(HasTimestamps):
    component = models.ForeignKey(Component, on_delete=models.PROTECT)
    quantity = models.PositiveIntegerField()
    original_quantity = models.PositiveIntegerField()
    total_value = models.DecimalField(max_digits=8, decimal_places=2)
    location = models.TextField()
    owner = models.ForeignKey(User, on_delete=models.SET_NULL, null=True)
    owner_name = models.CharField(max_length=150)
