from django.dispatch import Signal, receiver
from django.urls import reverse
from django.utils.translation import gettext as _

populate_nav = Signal()


@receiver(populate_nav, dispatch_uid="populate_nav_core")
def populate_nav_core(sender, **kwargs):
    request = sender

    if not request.user.is_authenticated:
        return []

    return [
        {
            "is_active": request.resolver_match.url_name == "add_stock",
            "link": reverse("add_stock"),
            "text": _("Add stock"),
        },
    ]
