let totalForms = Object.defineProperty({}, 'value', {
    get() {
        return +document.getElementById('id_form-TOTAL_FORMS').value;
    },

    set(value) {
        document.getElementById('id_form-TOTAL_FORMS').value = value;
    },

    enumerable: false,
    configurable: false,
});

const updateNames = (elem, i) => {
    const replaceIndex = s => s.replaceAll('__prefix__', `${i}`);

    if (elem.hasAttribute('for')) {
        elem.htmlFor = replaceIndex(elem.htmlFor);
    }

    if (elem.hasAttribute('id')) {
        elem.id = replaceIndex(elem.id);
    }

    if (elem.hasAttribute('name')) {
        elem.name = replaceIndex(elem.name);
    }

    for (const child of elem.children) {
        updateNames(child, i);
    }
};

const autofillQuantity = i => {
    const originalQuantity = document.getElementById(`id_form-${i}-original_quantity`);
    const quantity = document.getElementById(`id_form-${i}-quantity`);

    const autofillOnInput = (self, other) => () => {
        delete self.dataset.autofilled;

        if (!other.value || other.dataset.autofilled) {
            other.value = self.value;
            other.dataset.autofilled = true;
        }
    };

    originalQuantity.addEventListener('input', autofillOnInput(originalQuantity, quantity));
    quantity.addEventListener('input', autofillOnInput(quantity, originalQuantity));
};

const addFormButton = document.getElementById('addForm');

const addForm = () => {
    const form = document.getElementById('formTemplate').cloneNode(true);
    const i = totalForms.value++;
    updateNames(form, i);

    const heading = document.createElement('h3');
    heading.innerText = `#${i+1}`;

    addFormButton.before(heading, ...form.children);

    autofillQuantity(i);
    document.getElementById(`id_form-${i}-owner`).value = JSON.parse(document.getElementById('currentUser').textContent);
};

addFormButton.addEventListener('click', addForm);

for (let i = 0; i < totalForms.value; ++i) {
    autofillQuantity(i);
}
